ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.6 by root, Tue Dec 7 10:40:39 2010 UTC vs.
Revision 1.20 by root, Mon Dec 13 17:35:51 2010 UTC

2 2
3############################################################################# 3#############################################################################
4# configuration to fill in 4# configuration to fill in
5 5
6STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
7CPAN=http://mirror.netcologne.de/cpan/ # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9 9
10MKBUNDLE="$STATICPERL/mkbundle"
11
12# perl build variables 10# perl build variables
13PERL_PREFIX="$STATICPERL/perl" # where the perl gets installed
14PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 11PERL_VERSION=5.12.2 # 5.8.9 is also a good choice
12PERL_CC=cc
15PERL_CONFIGURE="" # additional Configure arguments 13PERL_CONFIGURE="" # additional Configure arguments
16PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 14PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP"
17PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 15PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
18 16
19ARCH="$(uname -m)" 17ARCH="$(uname -m)"
20 18
21case "$ARCH" in 19case "$ARCH" in
22 i*86 | x86_64 | amd64 ) 20 i*86 | x86_64 | amd64 )
23 PERL_OPTIMIZE="$PERL_OPTIMIZE -mpush-args -mno-inline-stringops-dynamically -mno-align-stringops -mno-ieee-fp" # x86/amd64 21 #PERL_OPTIMIZE="$PERL_OPTIMIZE -mpush-args -mno-inline-stringops-dynamically -mno-align-stringops -mno-ieee-fp" # x86/amd64
22 PERL_OPTIMIZE="$PERL_OPTIMIZE" # x86/amd64
24 case "$ARCH" in 23 case "$ARCH" in
25 i*86 ) 24 i*86 )
26 PERL_OPTIMIZE="$PERL_OPTIMIZE -fomit-frame-pointer -march=pentium3 -mtune=i386" # x86 only 25 PERL_OPTIMIZE="$PERL_OPTIMIZE -fomit-frame-pointer -march=pentium3 -mtune=i386" # x86 only
27 ;; 26 ;;
28 esac 27 esac
29 ;; 28 ;;
30esac 29esac
31 30
32# -Wl,--gc-sections makes it impossible to check for undefined references 31# -Wl,--gc-sections makes it impossible to check for undefined references
33# for some reason so we need to patch away the "-no" after Configure and before make :/ 32# for some reason so we need to patch away the "-no" after Configure and before make :/
34# -z muldefs is to work around uclibc's pthread static linking bug 33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
35PERL_LDFLAGS="-Wl,--no-gc-sections -z muldefs" 34PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
36PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
37 36
38# some configuration options for modules 37# some configuration options for modules
39export PERL_MM_USE_DEFAULT=1 38export PERL_MM_USE_DEFAULT=1
40#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 39#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
46 45
47# which extra modules you might want to install 46# which extra modules you might want to install
48EXTRA_MODULES="" 47EXTRA_MODULES=""
49 48
50# overridable functions 49# overridable functions
50preconfigure() { : ; }
51postconfigure() { : ; } 51postconfigure() { : ; }
52postbuild() { : ; } 52postbuild() { : ; }
53postinstall() { : ; } 53postinstall() { : ; }
54 54
55# now source user config, if any 55# now source user config, if any
56if [ "$STATICPERLRC" ]; then
57 . "$STATICPERLRC"
58else
56[ -r /etc/staticperlrc ] && . /etc/staticperlrc 59 [ -r /etc/staticperlrc ] && . /etc/staticperlrc
57[ -r ~/.staticperlrc ] && . ~/.staticperlrc 60 [ -r ~/.staticperlrc ] && . ~/.staticperlrc
58[ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc" 61 [ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc"
62fi
59 63
60############################################################################# 64#############################################################################
61# support 65# support
66
67MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
68PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
69
70unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
71export LC_ALL=C # just to be on the safe side
62 72
63# set version in a way that Makefile.PL can extract 73# set version in a way that Makefile.PL can extract
64VERSION=VERSION; eval \ 74VERSION=VERSION; eval \
65$VERSION=0.1 75$VERSION=0.911
66 76
67BZ2=bz2 77BZ2=bz2
68BZIP2=bzip2 78BZIP2=bzip2
69 79
70fatal() { 80fatal() {
103############################################################################# 113#############################################################################
104# clean 114# clean
105 115
106distclean() { 116distclean() {
107 verblock <<EOF 117 verblock <<EOF
108deleting everything installed by this script 118 deleting everything installed by this script (rm -rf $STATICPERL)
109EOF 119EOF
110 120
111 rm -rf "$STATICPERL" 121 rm -rf "$STATICPERL"
112} 122}
113 123
114############################################################################# 124#############################################################################
115# download/configure/compile/install perl 125# download/configure/compile/install perl
116 126
117clean() { 127clean() {
118 cd "$STATICPERL/src/perl-$PERL_VERSION" 2>/dev/null || return 128 rm -rf "$STATICPERL/src/perl-$PERL_VERSION"
119
120 rm -f staticstamp.configure
121 make distclean >/dev/null 2>&1
122} 129}
123 130
124fetch() { 131fetch() {
125 rcd "$STATICPERL" 132 rcd "$STATICPERL"
126 133
141 148
142 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 149 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side
143 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 150 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
144 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 151 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
145 || fatal "$URL: unable to download" 152 || fatal "$URL: unable to download"
153 rm -f perl-$PERL_VERSION.tar.$BZ2
146 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2 154 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2
147 fi 155 fi
148 156
149 verblock <<EOF 157 verblock <<EOF
150unpacking perl 158unpacking perl
151EOF 159EOF
152 160
153 mkdir -p unpack 161 mkdir -p unpack
162 rm -rf unpack/perl-$PERL_VERSION
154 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xpC unpack \ 163 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \
155 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 164 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking"
165 chmod -R u+w unpack/perl-$PERL_VERSION
156 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 166 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
157 rmdir -p unpack 167 rmdir -p unpack
158 fi 168 fi
159} 169}
160 170
161# similar to GNU-sed -i or perl -pi 171# similar to GNU-sed -i or perl -pi
162sedreplace() { 172sedreplace() {
163 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 173 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
174 rm -f "$2"
164 mv "$2~" "$2" 175 mv "$2~" "$2"
165} 176}
166 177
167configure() { 178configure() {
168 fetch 179 fetch
173 184
174 verblock <<EOF 185 verblock <<EOF
175configuring $STATICPERL/src/perl-$PERL_VERSION 186configuring $STATICPERL/src/perl-$PERL_VERSION
176EOF 187EOF
177 188
178 clean
179
180 rm -f "$PERL_PREFIX/staticstamp.install" 189 rm -f "$PERL_PREFIX/staticstamp.install"
190
191 make distclean >/dev/null 2>&1
181 192
182 # I hate them 193 # I hate them
183 grep -q -- -fstack-protector Configure && \ 194 grep -q -- -fstack-protector Configure && \
184 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 195 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
196
197 preconfigure
185 198
186# trace configure \ 199# trace configure \
187 sh Configure -Duselargefiles \ 200 sh Configure -Duselargefiles \
188 -Uuse64bitint \ 201 -Uuse64bitint \
189 -Dusemymalloc=n \ 202 -Dusemymalloc=n \
190 -Uusedl \ 203 -Uusedl \
191 -Uusethreads \ 204 -Uusethreads \
192 -Uuseithreads \ 205 -Uuseithreads \
193 -Uusemultiplicity \ 206 -Uusemultiplicity \
194 -Duseperlio \
195 -Uusesfio \ 207 -Uusesfio \
196 -Uuseshrplib \ 208 -Uuseshrplib \
209 -Dcc="$PERL_CC" \
197 -Dcppflags="$PERL_CPPFLAGS" \ 210 -Dcppflags="$PERL_CPPFLAGS" \
198 -Dccflags="-g2 -fno-strict-aliasing" \ 211 -Dccflags="-g2 -fno-strict-aliasing" \
199 -Doptimize="$PERL_OPTIMIZE" \ 212 -Doptimize="$PERL_OPTIMIZE" \
200 -Dldflags="$PERL_LDFLAGS" \ 213 -Dldflags="$PERL_LDFLAGS" \
201 -Dlibs="$PERL_LIBS" \ 214 -Dlibs="$PERL_LIBS" \
214 -Dpager=/usr/bin/less \ 227 -Dpager=/usr/bin/less \
215 -Demail="$EMAIL" \ 228 -Demail="$EMAIL" \
216 -Dcf_email="$EMAIL" \ 229 -Dcf_email="$EMAIL" \
217 -Dcf_by="$EMAIL" \ 230 -Dcf_by="$EMAIL" \
218 $PERL_CONFIGURE \ 231 $PERL_CONFIGURE \
232 -Duseperlio \
219 -dE || fatal "Configure failed" 233 -dE || fatal "Configure failed"
220 234
221 sedreplace ' 235 sedreplace '
222 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 236 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
223 s/ *-fno-stack-protector */ /g 237 s/ *-fno-stack-protector */ /g
245 259
246 postbuild || fatal "postbuild hook failed" 260 postbuild || fatal "postbuild hook failed"
247} 261}
248 262
249install() { 263install() {
250 [ -e "$PERL_PREFIX/staticstamp.install" ] && return 264 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
251
252 build 265 build
253 266
254 verblock <<EOF 267 verblock <<EOF
255installing $STATICPERL/src/perl-$PERL_VERSION 268installing $STATICPERL/src/perl-$PERL_VERSION
256to $PERL_PREFIX 269to $PERL_PREFIX
257EOF 270EOF
258 271
259 rm -rf "$PERL_PREFIX" 272 ln -sf "perl/bin/" "$STATICPERL/bin"
260 273 ln -sf "perl/lib/" "$STATICPERL/lib"
274
275 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
276 rm -rf "$PERL_PREFIX" # by this rm -rf
277
261 make install || fatal "make install: error while installing" 278 make install || fatal "make install: error while installing"
262 279
263 rcd "$PERL_PREFIX" 280 rcd "$PERL_PREFIX"
264 281
265 # create a "make install" replacement for CPAN 282 # create a "make install" replacement for CPAN
266 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 283 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF
267make install UNINST=1 284make || exit
285
268if find blib/arch/auto -type f | grep -q -v .exists; then 286if find blib/arch/auto -type f | grep -q -v .exists; then
269 echo Probably an XS module, rebuilding perl 287 echo Probably an XS module, rebuilding perl
270 make perl 288 if make perl; then
289 mv perl "$PERL_PREFIX"/bin/perl~ \
271 rm -f "$PERL_PREFIX"/bin/perl 290 && rm -f "$PERL_PREFIX"/bin/perl \
272 make -f Makefile.aperl inst_perl 291 && mv "$PERL_PREFIX"/bin/perl~ "$PERL_PREFIX"/bin/perl
273 make -f Makefile.aperl map_clean 292 make -f Makefile.aperl map_clean
293 else
294 make -f Makefile.aperl map_clean
295 exit 1
296 fi
274fi 297fi
298
299make install UNINST=1
275EOF 300EOF
276 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install 301 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
277 302
278 # trick CPAN into avoiding ~/.cpan completely 303 # trick CPAN into avoiding ~/.cpan completely
279 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 304 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
280 305
281 "$PERL_PREFIX"/bin/perl -MCPAN -e ' 306 "$PERL_PREFIX"/bin/perl -MCPAN -e '
282 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 307 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
283 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 308 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
284 CPAN::Shell->o (conf => q<init>); 309 CPAN::Shell->o (conf => q<init>);
285 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 310 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
286 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 311 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
287 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 312 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
288 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 313 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
289 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 314 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
290 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install"); 315 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install");
291 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 316 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
292 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 317 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>);
293 CPAN::Shell->o (conf => q<commit>); 318 CPAN::Shell->o (conf => q<commit>);
294 ' || fatal "error while initialising CPAN" 319 ' || fatal "error while initialising CPAN"
295 320
321 touch "$PERL_PREFIX/staticstamp.install"
322 fi
323
324 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then
296 NOCHECK_INSTALL=+ 325 NOCHECK_INSTALL=+
297 instcpan $STATICPERL_MODULES 326 instcpan $STATICPERL_MODULES
298 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES 327 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES
299 328
300 postinstall || fatal "postinstall hook failed" 329 postinstall || fatal "postinstall hook failed"
301 330
302 touch "$PERL_PREFIX/staticstamp.install" 331 touch "$PERL_PREFIX/staticstamp.postinstall"
332 fi
303} 333}
304 334
305############################################################################# 335#############################################################################
306# install a module from CPAN 336# install a module from CPAN
307 337
350############################################################################# 380#############################################################################
351# main 381# main
352 382
353podusage() { 383podusage() {
354 echo 384 echo
385
355 if [ -e "$PERL_PREFIX/bin/perl" ]; then 386 if [ -e "$PERL_PREFIX/bin/perl" ]; then
356 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \ 387 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \
357 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 388 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
358 2>/dev/null && exit 389 2>/dev/null && exit
359 fi 390 fi
391
360 # try whatever perl we can find 392 # try whatever perl we can find
361 perl -MPod::Usage -e \ 393 perl -MPod::Usage -e \
362 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 394 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
363 2>/dev/null && exit 395 2>/dev/null && exit
364 396
365 fatal "displaying documentation requires a working perl - try '$0 install' first" 397 fatal "displaying documentation requires a working perl - try '$0 install' to build one in a safe location"
366} 398}
367 399
368usage() { 400usage() {
369 podusage 0 401 podusage 0
370} 402}
380} 412}
381 413
382bundle() { 414bundle() {
383 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 415 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
384 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 416 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
417 CACHE="$STATICPERL/cache"
418 mkdir -p "$CACHE"
385 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" "$@" 419 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
386} 420}
387 421
388if [ $# -gt 0 ]; then 422if [ $# -gt 0 ]; then
389 while [ $# -gt 0 ]; do 423 while [ $# -gt 0 ]; do
390 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create" 424 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create"
391 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create" 425 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create"
392 426
393 command="${1#--}"; shift 427 command="${1#--}"; shift
394 case "$command" in 428 case "$command" in
429 version )
430 echo "staticperl version $VERSION"
431 ;;
395 fetch | configure | build | install | clean | distclean) 432 fetch | configure | build | install | clean | distclean)
396 verblock <<EOF
397$command
398EOF
399 ( "$command" ) 433 ( "$command" )
400 ;; 434 ;;
401 instsrc ) 435 instsrc )
402 ( instsrc "$@" ) 436 ( instsrc "$@" )
403 exit 437 exit
417 exit 451 exit
418 ;; 452 ;;
419 mkperl ) 453 mkperl )
420 ( install ) 454 ( install )
421 bundle --perl "$@" 455 bundle --perl "$@"
456 exit
457 ;;
458 mkapp )
459 ( install )
460 bundle --app "$@"
422 exit 461 exit
423 ;; 462 ;;
424 help ) 463 help )
425 podusage 2 464 podusage 2
426 ;; 465 ;;

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines